.TH STARTUP 1L "1 March 1991"
.SH NAME
startup \- A rsh invocation of a command in many nodes
.SH SYNOPSIS
.B startup
[
.B \-f 
.I nodefile
]
.I command
.SH DESCRIPTION
.B startup
executes the specified 
.I command
in the nodes that are listed in the
.BR nodefile.
If the user doesn't specify a 
.I nodefile
,
.B startup
searches for ~/.nodefile and a ./.nodefile with that order.
If no file  
is located or loaded succesfully an error message is printed.
.SH OPTIONS
.TP
.BI \-f " nodefile" 
The node list is located in the file named 
.I nodefile
.
.SH EXAMPLES
.IP
example% startup -f mynodes ps ux
.PP
The startup command is used primarly for starting up the Tuple Managers.
What I do is to define one of the node variables (i.e. #0) to be the location
of the Tuple Manager executable for each node and then issue the 
command: 
.IP
example% startup -f mynodes #0
.PP
where #0 will be ~/posybl/bin/tmanager.mips for a decstation
and ~/posybl/bin/tmanager.sun4 for a sun-4 workstation.
.SH FILES
 ~/.nodefile,
 ./.nodefile
.SH SEE ALSO
.BR NodeFile(1L),
.BR system(1L),
.BR tmanager(1L),
.BR posybl(1L).
.SH BUGS (Some call them features)
Instead, of using this command the Tuple Managers should be started 
by the Internet daemon (inetd). But, it was difficult to experiment
since I am not a network administrator and so I bypassed the problem,
by using this program. 
.SH AUTHOR
Ioannis Schoinas, sxoinas@csd.uch.gr
.SH ACKNOWLEDGEMENTS
I would like to thank everybody that helped me in writing this program
and especially I. Kavaklis for offering his ideas, some pieces of code,
demo programs, and for being the first subject to test this system.
